//-----------------------------------------------------
//  Rȓȉ~֐Ɠ꒵т̕RvZ
// vO͉L̎ɂ܂
// http://fuchino.ddo.jp/yatsugatake/ellipticx.pdf
// http://www.wannyan.net/scidog/ellipse/ellipse.pdf
//-----------------------------------------------------
unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, VclTee.TeeGDIPlus,
  VCLTee.TeEngine, VCLTee.Series, VCLTee.TeeProcs, VCLTee.Chart;

type
  TForm1 = class(TForm)
    LabeledEdit10: TLabeledEdit;
    LabeledEdit11: TLabeledEdit;
    Memo1: TMemo;
    nawaBtn: TButton;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TPointSeries;
    LabeledEdit1: TLabeledEdit;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    LabeledEdit2: TLabeledEdit;
    Series4: TPointSeries;
    Series5: TLineSeries;
    LabeledEdit3: TLabeledEdit;
    Series3: TLineSeries;
    Label2: TLabel;
    procedure nawaBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private 錾 }
    function calc_first_elliptic_integral(k, sinQ: double): double;
    function calc_second_elliptic_integral(k, sinQ: double): double;
    function jacobi_sn(u, k: double): double;
    function invertK(L, a2: double): double;
    function second_imperfect_elliptic_integral(Q, K: double; F: integer): double;
    procedure tangent(a2, k, b, c, alpha, ty: double; var x, y:double);
    procedure intersection(a2, k, b, c, alpha, z, lx, rx, ty, by, x0, y0: double);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Math;


var
  V : integer;                      // sn(u, k)vZLoop
  DBL_EPSILON : double;

//-------------------------------
// PQsSϕ
// FBnKn[0] PsSϕ
// EBnKn[0] QsSϕ
// fϊ
// Q px rad
// K S
// F = 1 ϕ F <> 1 ϕ
//-------------------------------
function TForm1.second_imperfect_elliptic_integral(Q, K: double; F: integer): double;
var
  I, MI   : integer;
  Kn      : array of double;         // Kn
  knd     : array of double;         // k'n
  N2SKn   : array of double;         // 2/(1+Kn)
  T2SKnd  : array of double;         // P2/(1+Kn')
  BRad    : array of double;         // (rad)
  SinBn   : array of double;         // sinn
  FBnKn   : array of double;         // F(n,kn)
  EBnKn   : array of double;         // E(n,kn)
  LnD     : double;
begin
  // K = 0 ͉̎~Ȃ̂pi̊pxlradB
  if K = 0 then begin
    result := Q;
    exit;
  end;

  // 1 >= K > 0 ̎
  MI := 0;
  LnD := 0;
  setlength(kn,  MI + 1);         // kn
  kn[0] := K;
  while LnD <> Kn[MI] do begin    // LnDkn[]PɂȂ܂łԂ܂
    LnD := Kn[MI];
    inc(MI);
    setlength(kn,  MI + 1);       // kn
    kn[MI] := 2 * sqrt(Kn[MI - 1])/(1 + Kn[MI - 1]);
  end;
  setlength(kn,      MI);         // kn
  setlength(knd,     MI);         // k'n
  setlength(N2SKn,   MI);         // 2/(1+Kn)
  setlength(T2SKnd,  MI);         // P2/(1+Kn')
  setlength(BRad,    MI);         // (rad)
  setlength(SinBn,   MI);         // sinn
  setlength(FBnKn,   MI);         // F(n,kn)
  setlength(EBnKn,   MI);         // E(n,kn)

  dec(MI);
  knd[0] := 1;
  for I := 1 to MI do
    knd[I] := (1 - kn[I - 1]) / (1 + Kn[I - 1]);
  for I := 0 to MI do
    N2SKn[I] := 2 / (1 + kn[I]);
  T2SKnd[MI] := N2SKn[MI];
  for I := MI - 1 downto 0 do
    T2SKnd[I] := T2SKnd[I + 1] * N2SKn[I];
  BRad[0] := Q;
  for I := 1 to MI do
    BRad[I] := (arcsin(kn[I - 1] * sin(Brad[I - 1])) + Brad[I - 1]) / 2;
  for I := 0 to MI do
    SinBn[I] := sin(Brad[I]);
  result := (1 + sin(Brad[MI])) / cos(Brad[MI]);
  if result <= 0 then exit;           // 0ȉ͎Rΐ̌vZo܂
  LnD := Ln(result);
  if F = 1 then begin                 // wȂ
    result := T2SKnd[0] * LnD;        // 
    exit;
  end;
  for I := 0 to MI do
    FBnKn[I] := T2SKnd[I] * LnD;
  EBnKn[MI] := sin(Brad[MI]);
  for I := MI - 1 downto 0 do
    EBnKn[I] :=  (2 * EBnKn[I + 1] + 2 * knd[I + 1] * FBnKn[I + 1]) / (1 + knd[I + 1]) - kn[I] * SinBn[I];
  result := EBnKn[0];                 // 
end;

// ȉ~ϕ [`
// sin() P
function TForm1.calc_first_elliptic_integral(k, sinQ: double): double;
var
  asin : double;
begin
  asin := abs(sinQ);
  if (k >= 1) and (asin >= 1) then        // ϕoȂl
    result := MaxDouble                   // doubleőlZbg̑
  else
    result := second_imperfect_elliptic_integral(arcsin(asin),  K,  1);  // sSϕ
  if sinQ < 0 then result := -result;
end;

// ȉ~ϕ [`
// sin() P
function TForm1.calc_second_elliptic_integral(k, sinQ: double): double;
var
  asin    : double;
begin
  asin := abs(sinQ);
  if (K >= 1) and (sinQ >= 1) then        // ϕoȂl
    result := 1
  else
    result := second_imperfect_elliptic_integral(arcsin(asin),  K,  2);  // sSϕ
  if sinQ < 0 then result := -result;
end;

// Jacobi֐ Jacobi sn(u, k)
function TForm1.Jacobi_sn(u, k: double): double;
const
  KN = 30;
var
  a: array of double;
  g: array of double;
  c: array of double;
  two_n   : double;
  phi     : double;
  half    : double;
  i, j    : integer;
begin
  half := 1 / 2;
  if k = 0 then begin
    result := sin(u);
    exit;
  end;
  if k = 1 then begin
    result := sin(2 * arctan(exp(u)) - pi / 2);
    exit;
  end;
  setlength(a, KN + 1);
  setlength(g, KN + 1);
  setlength(c, KN + 1);
  a[0] := 1;
  g[0] := sqrt(1 - k * k);
  c[0] := k;
  two_n := 1;
  for i := 0 to KN - 1 do begin
    if abs(a[i] - g[i]) < a[i] * DBL_EPSILON then break;
    two_n := two_n + two_n;
    a[i + 1] := half * (a[i] + g[i]);
    g[i + 1] := sqrt(a[i] * g[i]);
    c[i + 1] := half * (a[i] - g[i]);
  end;
  V := i;
  phi := two_n * a[i] * u;
  for j := i downto 1 do
    phi := half * (phi + arcsin(c[j] * sin(phi) / a[j]));
  result := sin(phi);
end;

// Xw肳ꂽ̐ړ_ʒǔvZ
//  sn'z=((1-sn^2z)(1-k^2sn^2z)) snzvZ
// Ȑ̌X΃=sn'z b/c
// a2     ꒵т̎xԋ
// k      S
// b      ꒵ѕR̍
// c      ȐW
// alpha  X
// ty     Otl
// x,y    ړ_W
procedure TForm1.tangent(a2, k, b, c, alpha, ty: double; var x, y:double);
var
  dx, u, snzk   : double;
  a             : double;
  dy, z         : double;
  A1, B1        : double;
  a0, b0, c0    : double;
begin
  // [_őX(b / c)ɑ΂郿̊mF
  if abs(alpha) > (b / c)  then begin                 // [_̌X蒼̌X傫ꍇ
    x := 0;
    y := -1;                                          // ڐ
    exit;
  end;
  a := a2 / 2;                                        // RSʒu
  // ̌XƗSkȉ~֐snzǩvZ
  A1 := alpha * c / b;
  a0 := k * k;
  b0 := -1 - a0;
  c0 := 1 - A1 * A1;
  B1 := (-b0 - sqrt(b0 * b0 - 4 * a0 * c0)) / 2 / a0;
  snzk := sqrt(B1);                                   // sn(z,k)
  // WvZ
  u := calc_first_elliptic_integral(k, snzk);         // sSȉ~ϕ  (rad)=arcsin(snzk)
  x := u * c;                                         // xW
  x := x - a;                                         // xW𒆐SWɕϊ
  y := snzk * b;                                      // xʒuy̒l
  if alpha < 0 then x := - x;                         // X}CiX̏ꍇxt
  Series4.AddXY(x, y);                                // Otɐړ_̈ʒuǉ
  memo1.Lines.Add('Xΐړ_W@    x = ' + floatTostrF(x, ffFixed, 10, 6));
  memo1.Lines.Add('Xΐړ_W@    y = ' + floatTostrF(y, ffFixed, 10, 6));
  // ڐ̕`
  z := y - alpha * x;                                 // ؕЂ̌vZ
  dx := 0 - a;                                        // n_x
  dy := alpha * dx + z;                               // n_y
  if dy > ty then begin                               // y̒lOt̏𒴂璲
    dx := (ty - z) / alpha;
    dy := ty;
  end;
  Series5.AddXY(dx, dy);                              // Otɒǉ
  dx := a2 - a;                                       // I_x
  dy := alpha * dx + z;                               // I_y
  if dy > ty then begin                               // y̒lOt̏𒴂璲
    dx := (ty - z) / alpha;
    dy := ty;
  end;
  Series5.AddXY(dx, dy);                              // Otɒǉ
end;

// a2     ꒵т̎xԋ
// k      S
// b      ꒵ѕR̍
// c      ȐW
// alpha  X
// z      ؕ
// lx, rx OtE
// ty, by Ot
// x0, y0 ړ_W
procedure TForm1.intersection(a2, k, b, c, alpha, z, lx, rx, ty, by, x0, y0: double);
const
  KN = 8;
  Mi = 1000;
var
  i     : integer;
  a, z0 : double;
  x,  y   : double;
  xs, ys  : double;
  xe, ye  : double;
  yl    : double;
  CRF   : byte;  // 0 _Ȃ 1 _ꂩ 2 _񂩏  3 _ʉߐ
  dx, u : double;
  N, Mn : integer;
  ax    : double;

  // _\
  procedure datoutput(x, y: double; N: integer);
  begin
    Series4.AddXY(x, y);                             // Otɒǉ
    memo1.Lines.Add('_W@        x' + intTostr(N) + '= ' + floatTostrF(x, ffFixed, 10, 6));
    memo1.Lines.Add('_W@        y' + intTostr(N) + '= ' + floatTostrF(y, ffFixed, 10, 6));
  end;

begin
  CRF := 0;
  a := a2 / 2;
  // X΂[łȂꍇ
  if alpha <> 0 then begin
    x := - z / alpha;             // y=0̎x̒lvZ
    if y0 < 0 then begin          // wX΂̐ړ_Ƃ
      if (-a <= x ) and (x <= a) then CRF := 1  // y=0 xWR̎xԓ̎_ꂩ
                                 else CRF := 0; // xԊO̎_
    end
    else begin                    // wX΂̐ړ_ꍇ
      z0 := y0 - x0 * alpha;      // ړ_ʂ钼̐ؕ
      ax := a + DBL_EPSILON * a;
      if z > 0 then
        ax := a - DBL_EPSILON * a;  // Z덷ɂ锻~XCׂ̈̒l _L葤ɐݒ
      if (z < z0) then begin        // ڐ̐ؕЂw蒼̐ؕЂꍇ
        if (x <= -ax) and (alpha >= 0) then CRF := 2; // XΊpvX̎ŁAx̒l[O̎_񂩏
        if (x >=  ax) and (alpha <= 0) then CRF := 2; // XΊp}CiX̎ŁAx̒lE[O̎_񂩏
        if (-ax < x) and (x < ax) then CRF := 1;      // x̒lxԓ̎_ꂩ
      end;
    end;
  end
  else begin
  // X΂[̎
    if (0 < z) and (z <= b) then CRF := 2;          // R̋Ȑ͈̍͂Ȃ_񂩏
    if 0 = z then CRF := 3;                         // _ʉߐ
  end;
  Mn := 0;
  dx := a2 / KN;
  N := 1;
  if CRF = 0 then  memo1.Lines.Add('_');
  if (CRF = 1) and (alpha > 0) then begin           // _ꂩŌX΃vX̎̌_
    x := 0;                                         // [猟
    i := 0;
    repeat
      x := x + dx;                                  // E֌
      u := x / c;                                   // F(,k)=u
      y := b * jacobi_sn(u, k);                     // xʒuy̒l
      yl := alpha * (x - a) + z;                    // xʒuy̒l
      if yl > y then begin
        x := x - dx;
        dx := dx / 2;
      end;
      inc(i);
    until (dx <= DBL_EPSILON * a) or (i > Mi);
    x := x - a;
    datoutput(x, y, N);
    Mn := i;
  end;
  if (CRF = 1) and (alpha < 0) then begin           // _ꂩŌX΃}CiX̎̌_
    x := a2;                                        // E[猟
    i := 0;
    repeat
      x := x - dx;                                  // ֌
      u := x / c;                                   // F(,k)=u
      y := b * jacobi_sn(u, k);                     // xʒuy̒l
      yl := alpha * (x - a) + z;                    // xʒuy̒l
      if yl > y then begin
        x := x + dx;
        dx := dx / 2;
      end;
      inc(i);
    until (dx <= DBL_EPSILON * a) or (i > Mi);
    x := x - a;
    datoutput(x, y, N);
    if i > Mn then Mn := i;
  end;
  if CRF = 2 then begin                             // _񂩏̎̌_
    x := x0 + a;                                    // Jn_ڐʒuɃZbg
    i := 0;
    repeat
      x := x + dx;                                  // E֌
      u := x / c;                                   // F(,k)=u
      y := b * jacobi_sn(u, k);                     // xʒuy̒l
      yl := alpha * (x - a) + z;                    // xʒuy̒l
      if yl > y then begin
        x := x - dx;
        dx := dx / 2;
      end;
      inc(i);
    until (dx <= DBL_EPSILON * a) or (i > Mi);      // 
    x := x - a;
    datoutput(x, y, N);
    inc(N);
    if i > Mn then Mn := i;
    x := x0 + a;                                    // Jn_ڐʒuɃZbg
    i := 0;
    dx := a2 / KN;
    repeat
      x := x - dx;                                  // ֌
      u := x / c;                                   // F(,k)=u
      y := b * jacobi_sn(u, k);                     // xʒuy̒l
      yl := alpha * (x - a) + z;                    // xʒuy̒l
      if yl > y then begin
        x := x + dx;
        dx := dx / 2;
      end;
      inc(i);
    until (dx <= DBL_EPSILON * a) or (i > Mi);      // 
    if i > Mn then Mn := i;
    x := x - a;
    datoutput(x, y, N);
  end;
  if CRF = 3 then begin                             // Ō_ʂꍇ
    x := -a;
    y := 0;
    N := 1;
    datoutput(x, y, N);
    x := a;
    N := 2;
    datoutput(x, y, N);
  end;
  // ̕`
  // OtmFƒ`pWvZ
  ys := alpha * lx + z;
  xs := lx;
  if ys > ty then begin
    xs := (ty - z) / alpha;
    ys := ty;
  end;
  if ys < by then begin
    xs := (by - z) / alpha;
    ys := by;
  end;
  xe := rx;
  ye := alpha * rx + z;
  if ye > ty then begin
    xe := (ty - z) / alpha;
    ye := ty;
  end;
  if ye < by then begin
    xe := (by - z) / alpha;
    ye := by;
  end;
  // OtȂ`
  if (xs >= lx) and (xe <= rx) and (ys >= by) and (ys <= ty)
                               and (ye >= by) and (ye <= ty) then begin
    Series3.AddXY(xs, ys);                              // Otɒǉn_
    Series3.AddXY(xe, ye);                              // OtɒǉI_
  end
  else
    memo1.Lines.Add('w肳ꂽ̓OtO');
  if Mn <> 0 then
    memo1.Lines.Add('_őLoop ' + intTostr(Mn));
end;

// cǩvZ
// L=4a/k'^2*E/K-2aaLmȂ̂k̒l߂܂B
// L    R̒
// a2   xԋ
function TForm1.invertK(L, a2: double): double;
const
  KN = 500;
var
  c, fc     : double;
  k, E, Fk  : double;
  dk        : double;
  N         : integer;
begin
  a2 := abs(a2);
  c := (L + a2) / a2 / 2;                     // L=4a/k'^2*E/K-2a 画pŒlvZ
  k := 0;                                     // Sl
  dk := 1 / 2;                                // k
  N := 0;
  repeat
    inc(N);
    k := k + dk;                              // k+k
    if k >= 1 then k := 1 - DBL_EPSILON;      // k1ɐ1͂ɏ܂B
    E := calc_second_elliptic_integral(k, 1); // 튮Sϕ
    Fk := calc_first_elliptic_integral(k, 1); // 튮Sϕ
    fc := E / Fk / (1 - k * k);               // rlvZ
    if fc > c then begin                      // 傫
      k := k - dk;                            // kZ
      dk := dk / 2;                           // k@21
    end;
  until (dk <= DBL_EPSILON * k) or (N > KN);  // 
  memo1.Lines.Add('cvZ[v N = ' + intTostr(N));
  result := k;
end;

// ꒵т̓o݌vZ
procedure TForm1.nawaBtnClick(Sender: TObject);
const
  kN  = 400;
var
  k         : double;     // k   S
  ch        : integer;
  a, a2     : double;     // a2  Rx   a = a2 / 2
  Fkd       : double;     // Fkd 튮Sϕ
  b, u      : double;     // b   ꍂ     F(,k)=u
  c, L      : double;     // c   ȐW   L ̎w蒷
  i         : integer;
  x, y, dx  : double;     // x,y ̍W dx = x
  snuk      : double;     // snuk := jacobi_sn(u, k)
  ty, by    : double;     // ty  Ot  by  Ot
  lx, rx    : double;     // lx  Ot  rx  OtE
  def, ddf  : double;     // Ot]
  Ek        : double;     // Ek  튮~ϕ
  Lk        : double;     // LK  Sw R
  alpha     : double;     //   ̌X
  z         : double;     // z   ̐ؕ
  x0, y0    : double;     // x0,y0 X΃̐ړ_
begin
  V := 0;
  k := 0;
  L := 0;
  val(Labelededit10.Text, a2, ch);
  if ch <> 0 then begin
    application.MessageBox('꒵ѕRxԂɊԈႢ܂B','',0);
    exit;
  end;
  val(Labelededit2.Text, alpha, ch);
  if ch <> 0 then begin
    application.MessageBox('̌XɊԈႢ܂B','',0);
    exit;
  end;
  val(Labelededit3.Text, z, ch);
  if ch <> 0 then begin
    application.MessageBox('̐ؕЂɊԈႢ܂B','',0);
    exit;
  end;
  if checkbox1.Checked then begin
    val(LabeledEdit1.Text, k, ch);
    if ch <> 0 then begin
      application.MessageBox('꒵ѕRSjɊԈႢ܂B','',0);
      exit;
    end;
    if k >= 1 then begin
      application.MessageBox('k(S)̂͂PȉɂĉB','',0);
      exit;
    end;
    if k < 0 then begin
      application.MessageBox('k(S)̒lɃ}CiX͂܂B','',0);
      exit;
    end;
  end
  else begin
    val(LabeledEdit11.Text, L, ch);
    if ch <> 0 then begin
      application.MessageBox('꒵ѕR̒ɊԈႢ܂B','',0);
      exit;
    end;
    if L <= abs(a2) then begin
      application.MessageBox('R͎̒xԂ蒷ĂB','',0);
      exit;
    end;
  end;
  memo1.Clear;
  if not checkbox1.Checked then begin
    memo1.Lines.Add('R̒(L=' + floatTostr(L) + ')wvZ');
    k := invertK(L, a2);                                    // cǩvZ
    memo1.Lines.Add('c@@@@ @@@  k = ' + floatTostrF(k, ffFixed, 10, 6));
  end
  else
    memo1.Lines.Add('S(k=' + floatTostr(k) + ')wvZ');
  Fkd := calc_first_elliptic_integral(k, 1);                // 튮Sϕ90
  // evZ
  a := a2 / 2;                                              // a ʒu90
  c := a / Fkd;                                             // ϕlɑ΂ȐW
  b := 2 * k / (1 - k * k) * c;                             // ő卂 ̈ʒu
  memo1.Lines.Add('ȐW@@@@@@  c = ' + floatTostrF(c, ffFixed, 10, 6));
  memo1.Lines.Add('R̒S@ @@@ b = ' + floatTostrF(b, ffFixed, 10, 6));
  // R̒vZ ԈʒǔvZ͏o܂
  if checkbox1.Checked then begin
    Ek := calc_second_elliptic_integral(k, 1);              // 튮~ϕ90
    Lk := 4 * c * Ek / (1 - k * k) - a2;                    // (R)̒vZ
    memo1.Lines.Add('R̒@@@@@@@@L = ' + floatTostrF(Lk, ffFixed, 10, 6));
  end;
  Series1.Clear;
  Series2.Clear;
  Series3.Clear;
  Series4.Clear;
  Series5.Clear;
  // OtXP[ݒ
  if abs(a2) > b then begin
    ddf := a2 / 10;
    def := (a2 - b) / 2;
    ty := b + def + ddf;
    by := 0 - def - ddf;
    rx :=  a + ddf;
    lx := -a - ddf;
  end
  else begin
    ddf := b / 10;
    def := (b - a2) / 2;
    ty := b + ddf;
    by := 0 - ddf;
    rx :=  a + def + ddf;
    lx := -a - def - ddf;
  end;
  // Ot̃XP[ݒlZbg
  Series2.AddXY(lx, ty);
  Series2.AddXY(lx, by);
  Series2.AddXY(rx, by);
  application.ProcessMessages;                      // Ot\҂
  // Ot}
  dx := a2 / KN;                                    // X
  // 0`KN@vZ}
  for i := 0 to KN do begin
    x := i * dx;                                    // xʒu
    u := x / c;                                     // F(,k)=u
    snuk := jacobi_sn(u, k);                        // jacobi_sn  Rȓȉ~֐
    y := snuk * b;                                  // xʒuy̒l
    Series1.AddXY(x - a, y);                        // Otɒǉ
  end;
  application.ProcessMessages;
  tangent(a2, k, b, c, alpha, ty, x0, y0);          // ړ_Wx0,y0̌vZ
  intersection(a2, k, b, c, alpha, z, lx, rx, ty, by, x0, y0);   // _̌vZ
  Label1.Caption := 'sn(u) őLoop= ' + intTostr(V);
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then begin
    labeledEdit1.Enabled := True;
    labeledEdit11.Enabled := False;
  end
  else begin
    labeledEdit1.Enabled := False;
    labeledEdit11.Enabled := True;
  end;
end;

procedure TForm1.CheckBox1KeyPress(Sender: TObject; var Key: Char);
begin
  if CheckBox1.Checked then CheckBox1.Checked := False
                       else CheckBox1.Checked := True;
end;

procedure TForm1.FormCreate(Sender: TObject);
const
  IM = 50;
var
  x, y, z : double;
  i       : integer;
begin
  labeledEdit1.Enabled := False;
  // lݒ
  i := 0;
  x := 1;
  y := 1 / 4194304;                           // 4194304 = 2^22
  repeat
    y := y / 2;
    z := x + y;                               // mFZ
    inc(i);
  until (z = 1) or (i > IM) ;                 // ܂ŌJԂ
  DBL_EPSILON := y * 2;                       // DBL_EPSILON l
end;

end.


